#! /bin/sh

hostname
echo $*

jobset=$1
method="$2"
dataset="$3"
seq_len=$4
out_rootdir="$5"
shift 5

train_domains=(55)
num_queries=(50)
if [ "${jobset}" = "domain" ]; then
    train_domains=(50 40 30 20 10)
elif [ "${jobset}" = "data" ]; then
    num_queries=(40 30 20 10)
elif [ "${jobset}" = "domain_fullset" ]; then
    train_domains=(55 50 40 30 20 10)
elif [ "${jobset}" = "data_fullset" ]; then
    num_queries=(50 40 30 20 10)
fi

num_ar_feature=3
# predict_support=3
train_support=3
support_seq_len=${seq_len}
predict_freq=1

script_img="scripts/plot_png.py"
script_pdf="scripts/plot_predicts.py"

for predict_support in `seq 1 10`; do

for train_domain in ${train_domains[@]}; do
    for num_query in ${num_queries[@]}; do
        outdir="${out_rootdir}/train${train_domain}_predict_support${predict_support}_data${num_query}_seq${seq_len}/dataset${dataset}/${method}"
        if [ ! -e ${outdir} ]; then
            continue
        fi
        opts="--targets target"
        # if [ ${test_flg} -eq 1 ]; then
        #     opts="${opts} target train validation"
        # fi
        command="python ${script_img} ${outdir} ${opts}"
        echo ${command}
        ${command}
        command="python ${script_pdf} ${outdir} ${opts}"
        echo ${command}
        ${command}
    done
done

done