#! -*- coding: utf-8
import os
import os.path as path
from glob import glob
from argparse import ArgumentParser

methods = ["attention", "maml", "cross_domain", ]

if __name__ == "__main__":
    parser = ArgumentParser()
    parser.add_argument("source_dir", type=str)
    parser.add_argument("dest_dir", type=str)
    parser.add_argument("--methods", type=str, nargs="+",
                        default=["attention", "cross_domain", "maml"],
                        choices=methods)
    args = parser.parse_args()

    # os.makedirs(args.dest_dir, exist_ok=True)
    for method in args.methods:
        files = list(glob(path.join(
            args.source_dir, "*", method, "target/img/*.png")))
        for source_file in files:
            # dataset番号を取得
            # 実験パラメータ(学習ドメイン数、support数)
            basename, ext = path.splitext(path.basename(source_file))
            domain = basename.split(".")[0]
            dataset = path.dirname(path.dirname(
                path.dirname(path.dirname(source_file))))
            hparams = path.basename(path.dirname(dataset))
            dataset = path.basename(dataset)
            dest_dir = path.join(args.dest_dir, hparams, domain)
            os.makedirs(dest_dir, exist_ok=True)
            dest_file = path.join(dest_dir,
                                  "%s.%s.%s%s" % (basename, dataset, method, ext))
            # print(source_file, dest_file)
            if path.isfile(dest_file):
                os.remove(dest_file)
            os.link(source_file, dest_file)
