#! -*- coding: utf-8
import os
import os.path as path
from glob import glob
import pandas as pd
import numpy as np

from argparse import ArgumentParser

if __name__ == "__main__":
    parser = ArgumentParser()
    parser.add_argument("rootdir", type=str)
    parser.add_argument("--delimiter", type=str, default="\t")
    args = parser.parse_args()

    score = pd.concat([pd.read_csv(f, sep=args.delimiter)
                       for f in glob(path.join(args.rootdir, "dataset*", "score_dataset*.tsv"))])
    score.reset_index(inplace=True, drop=True)
    # new_row = ["average"]
    # new_row.extend(score.mean().values)
    # score.loc[len(score)] = new_row
    summaries = []
    new_row = ["average"]
    new_row.extend(score.mean().values)
    summaries.append(new_row)
    new_row = ["median"]
    new_row.extend(score.median().values)
    summaries.append(new_row)
    new_row = ["var"]
    new_row.extend(score.std().values)
    summaries.append(new_row)
    new_row = ["stderr"]
    new_row.extend(score.var().values)
    summaries.append(new_row)
    for summary in summaries:
        score.loc[len(score)] = summary

    score.to_csv(path.join(args.rootdir, "score.csv"), index=False)
