#! -*- coding: utf-8
import os
import os.path as path
from glob import glob
import pandas as pd
import numpy as np

from argparse import ArgumentParser

if __name__ == "__main__":
    parser = ArgumentParser()
    parser.add_argument("rootdir", type=str)
    parser.add_argument("--delimiter", type=str, default=",")
    args = parser.parse_args()

    # cols = ["domain", "category",
    #         "domain_specific", "cross_doamin",
    #         "meta_learning", "bidirectional", "attention",
    #         "linear", "nonlinear",
    #         "domain_specific_linear", "domain_specific_nonlinear", "diff_previous"]
    cols = ["domain", "category",
            "attention", "attention_only",
            "domain_specific", "cross_domain",
            "meta_learning", "bidirectional",
            "linear", "nonlinear",
            "maml", "maml_linear", "maml_nonlinear",
            "domain_specific_linear", "domain_specific_nonlinear",
            "diff_previous"]

    score = []

    for f in glob(path.join(args.rootdir, "dataset*", "score.csv")):
        dataset_no = path.basename(path.dirname(f))
        dataset = path.basename(path.dirname(f))
        df = pd.read_csv(f, sep=args.delimiter)
        # filter target
        df = df.loc[df["type"] == "target", cols].copy()
        # df[cols[2:]] = np.sqrt(df.loc[:, cols[2:]])
        df["dataset"] = dataset_no
        score.append(df)
    score = pd.concat(score)
    # カラム順の並び替え
    new_cols = ["dataset"]
    new_cols.extend(cols)
    score = score.loc[:, new_cols].copy()
    bests = np.argmin(score.iloc[:, 3:].values, axis=1)
    means = np.mean(score.iloc[:, 3:].values, axis=1)
    sigmas = np.var(score.iloc[:, 3:].values, axis=1)
    score["best"] = bests
    score["mean"] = means
    score["var"] = sigmas

    score.to_csv(
        path.join(args.rootdir, "score_domain_dataset.csv"), index=False)
    s = np.mean(np.sqrt(score.loc[:, cols[2:]]), axis=0)
    s = pd.DataFrame([s])
    s.to_csv(
        path.join(args.rootdir, "score2.csv"), index=False)
    # score.groupby(["domain", "category"]).mean().to_csv(
    #     path.join(args.rootdir, "score_domain.csv"), index=True)
