#! -*- coding: utf-8
import os
import os.path as path
from glob import glob
from argparse import ArgumentParser
import pandas as pd

if __name__ == "__main__":
    parser = ArgumentParser()
    parser.add_argument("RootDir", type=str, help="各ドメインごとの予測結果を格納したディレクトリ")
    parser.add_argument("Score", type=str,  help="出力先")
    parser.add_argument("--delimiter", type=str,
                        default="\t", help="入力、出力ファイルの区切り文字")
    args = parser.parse_args()

    # header = ["domain", "train", "train_count", "validation",
    #           "validation_count", "test", "test_count"]
    header = ["domain", "train", "train_count", "validation",
              "validation_count", "target", "target_count"]
    with open(args.Score, "wt") as f:
        f.write(args.delimiter.join(header))
        f.write("\n")
        for filepath in sorted(list(glob(path.join(args.RootDir, "**/score.tsv")))):
            try:
                df = pd.read_csv(filepath, sep=args.delimiter, dtype={
                    "error": float, "count": int})
                df = df[df["domain"] != df["type"]]
                domain = df.loc[0, "domain"]
                if ".query" in domain:
                    continue
                line = [domain]
                # for t in ["train", "validation", "test"]:
                for t in ["train", "validation", "target"]:
                    errors = df.loc[df["type"] == t, [
                        "error", "count"]].values.ravel()
                    line.append(errors[0])
                    line.append(int(errors[1]))
                f.write(args.delimiter.join(map(str, line)))
                f.write("\n")
            except Exception as e:
                print(e)
                print("invalid file %s" % filepath)
