#! -*- coding: utf-8
import os
import os.path as path
from glob import glob
from argparse import ArgumentParser
import pandas as pd

if __name__ == "__main__":
    parser = ArgumentParser()
    parser.add_argument("source", type=str)
    parser.add_argument("dest", type=str)
    parser.add_argument("--delimiter", type=str, default="\t")
    args = parser.parse_args()

    df = pd.read_csv(args.source, dtype={
                     "domain": str, "count": int, "error": float, "type": str}, sep=args.delimiter)
    df = df[~(df["domain"] == df["type"])]
    # for i, row in df.iterrows():
    #     domain = row.domain
    #     if ".query" in domain:
    #         df.loc[i, "domain"] = domain.replace(".query", "")

    # for i in range(len(df)):
    #     row = df.iloc[i]
    #     domain = row.domain
    #     if ".query" in domain:
    #         df.loc[i, "domain"] = domain.replace(".query", "")

    # header = ["domain", "train", "train_count", "validation",
    #           "validation_count", "test", "test_count"]
    header = ["domain", "train", "train_count", "validation",
              "validation_count", "target", "target_count"]
    with open(args.dest, "wt") as f:
        f.write(args.delimiter.join(header))
        f.write("\n")
        domains = sorted(list(df["domain"].unique()))
        for domain in domains:
            line = [domain.replace(".query", "")]
            for data_type in ["train", "validation", "target"]:
                subset = df[(df["domain"] == domain) &
                            (df["type"] == data_type)]
                if len(subset) == 0:
                    line.extend(["", ""])
                else:
                    errors = subset.loc[:, ["error", "count"]].values.ravel()
                    line.append(float(errors[0]))
                    line.append(int(errors[1]))
            f.write(args.delimiter.join(map(str, line)))
            f.write("\n")
            # print(domain, subset)
