#! /bin/sh

test_flg=0
# test_flg=1

jobset="domain_fullset"
modes=("fewshot")
seq_lens=(100)
input_seq=10

while [ $# -gt 1 ]; do
    if [ $1 = "jobset" ]; then
        jobset="$2"
        shift 2
    elif [ $1 = "mode" ]; then
        modes=("$2")
        shift 2
    elif [ $1 = "seq_len" ]; then
        seq_lens=($2)
        shift 2
    elif [ $1 = "input_seq" ]; then
        input_seq=$2
        shift 2
    else
        shift 1
    fi
done

val_domain=10
target_domain=25
sequence_length=100
query=50
predict_support=5
train_support=5
data_rootdir="./datas/val${val_domain}_target${target_domain}_seq${sequence_length}_support10_query${query}"

if [ ${test_flg} -eq 1 ]; then
    out_rootdir="./test"
    epochs=1
    rm -rf ${out_rootdir}
    startdataset="00"
    enddataset="00"
else
    out_rootdir="./results"
    epochs=500
    startdataset="00"
    # startdataset="05"
    enddataset="29"
    # enddataset="04"
fi

methods=("cross_domain" "linear" "nonlinear" "meta_learning" "bidirectional" "attention" "maml" "maml_linear" "maml_nonlinear" "domain_specific" "domain_specific_linear" "domain_specific_nonlinear")
# methods=("cross_domain" "linear" "nonlinear" "attention" "maml" "maml_linear" "maml_nonlinear" "domain_specific" "domain_specific_linear" "domain_specific_nonlinear")
# methods=("maml" "maml_linear" "maml_nonlinear")
# methods=("cross_domain" "linear" "nonlinear" "meta_learning" "bidirectional" "attention" "domain_specific" "domain_specific_linear" "domain_specific_nonlinear")
# methods=("attention" "maml" "cross_domain")
methods=("attention_oly" "bidirectional" "meta_learning")

for mode in ${modes[@]}; do
    outdir="${out_rootdir}/${mode}"
    if [ ! -e "${outdir}" ]; then
        mkdir -p ${outdir}
    fi
    for seq_len in ${seq_lens[@]}; do
        for dataset in `seq -w ${startdataset} ${enddataset}`; do
            for method in ${methods[@]}; do
                shell="train_cross_domain.sh"
                # "domain_specific" "domain_specific_linear" "domain_specific_nonlinear"
                if [ ${method} = "domain_specific" ]; then
                    shell="train_domain_specific.sh"
                elif [ ${method} = "domain_specific_linear" ]; then
                    shell="train_domain_specific.sh"
                elif [ ${method} = "domain_specific_nonlinear" ]; then
                    shell="train_domain_specific.sh"
                fi
                extra_args=""
                if [ ${mode} = "longterm" ]; then
                    extra_args="--input_seq ${input_seq}"
                fi
                
                jobname="${method}${dataset}"
                command="bash ${shell} ${test_flg} ${jobset} ${epochs} ${method} ${mode} ${dataset} ${seq_len} ${data_rootdir} ${outdir} ${predict_support} ${train_support} ${extra_args}"
                ret=`${command}`
                echo ${ret} ${command}
            done
        done
    done
done
